'''
SoSe 2011 - Uebungsblatt 1



Created on 21.04.2012

@author: Daniel Buschek
'''

if __name__ == '__main__':
    pass

import numpy as np
import matplotlib.pyplot as plt
import matplotlib.colors as colors




'''
Aufgabe 2
'''


' Teilaufgabe a) '

def imgToOneChannelGrayValueSimple(img):
    return (img[:,:,0] + img[:,:,1] + img[:,:,2]) / 3
#    return np.array([[(r+g+b)/3 for r, g, b in row] 
#           for row in img])

def imgToGrayValueSimple(img):
    return np.array([[colorToGrayValueSimple(r, g, b) for r, g, b in row] 
            for row in img])

def colorToGrayValueSimple(r, g, b):
    value = (r + g + b)/3
    return [value, value, value]
    


' Teilaufgabe b) '

def imgToOneChannelGrayValue(img):
    return np.array([[0.2126 * r + 0.7152 * g + 0.0722 * b for r, g, b in row] 
            for row in img])

def imgToGrayValue(img):
    return np.array([[colorToGrayValue(r, g, b) for r, g, b in row] 
            for row in img])

def colorToGrayValue(r, g, b):
    value = 0.2126 * r + 0.7152 * g + 0.0722 * b
    return [value, value, value]



' Teilaufgabe c) '
def aufgabe2c():
    img = plt.imread('nerds.png')
    img2 = imgToOneChannelGrayValueSimple(img)
    img3 = imgToOneChannelGrayValue(img)    
    plt.figure(1)
    plt.subplot(121)
    plt.imshow(img2)
    plt.subplot(122)
    plt.imshow(img3)
    plt.show()
# Optischer Unterschied: Besonders in blauen Bereichen zu erwarten, 
# da Blau kaum eine Rolle fuer die Formel aus Teilaufgabe b) spielt.



'''
Aufgabe 3
'''


' Teilaufgabe a) '

# IF src[i] > T THEN dst[i] = M ELSE dst[i] = 0
def thresholdBinary(img, t, m):
    new = np.zeros_like(img)
    h, w = img.shape
    for y in range(h):
        for x in range(w):
            if img[y, x] > t: new[y, x] = m
            else : new[y, x] = 0
    return new


# IF src[i] > T THEN dst[i] = 0 ELSE dst[i] = M
def thresholdBinaryInv(img, t, m):
    new = np.zeros_like(img)
    h, w = img.shape
    for y in range(h):
        for x in range(w):
            if img[y, x] > t: new[y, x] = 0
            else : new[y, x] = m
    return new
    
    
# IF src[i] > T THEN dst[i] = M ELSE dst[i] = src[i]
def thresholdTrunc(img, t, m):
    new = np.zeros_like(img)
    h, w = img.shape
    for y in range(h):
        for x in range(w):
            if img[y, x] > t: new[y, x] = m
            else : new[y, x] = img[y, x]
    return new    


# IF src[i] > T THEN dst[i] = 0 ELSE dst[i] = src[i]
def thresholdToZeroInv(img, t, m):
    new = np.zeros_like(img)
    h, w = img.shape
    for y in range(h):
        for x in range(w):
            if img[y, x] > t: new[y, x] = 0
            else : new[y, x] = img[y, x]
    return new  


# IF src[i] > T THEN dst[i] = src[i] ELSE dst[i] = 0
def thresholdToZero(img, t, m):
    new = np.zeros_like(img)
    h, w = img.shape
    for y in range(h):
        for x in range(w):
            if img[y, x] > t: new[y, x] = img[y, x]
            else : new[y, x] = 0
    return new  
    
    

' Teilaufgabe b) '

def grayValueStretch(img):
    min = np.min(img)
    max = np.max(img)
    # return np.array([[(v - min) / (max - min) for v in row] for row in img])
    img2 = img.copy()
    return (img2 - min) / (max - min)




'''
Tests Aufgabe 3:
'''

def aufgabe3a():
    img = imgToOneChannelGrayValue(plt.imread('nerds.png')) #Original
    img2 = thresholdBinary(img, 0.5, 1) #"Alles ueber 0.5 wird weiss, alles darunter schwarz."
    img3 = thresholdBinaryInv(img, 0.5, 1) #"Alles ueber 0.5 wird schwarz, alles darunter weiss."
    img4 = thresholdTrunc(img, 0.5, 1) #"Alles ueber 0.5 wird weiss, alles darunter bleibt wie es war."
    img5 = thresholdToZeroInv(img, 0.5, 1) #"Alles ueber 0.5 wird schwarz, alles darunter bleibt wie es war."
    img6 = thresholdToZero(img, 0.5, 1) #"Alles ueber 0.5 bleibt wie es war, alles darunter wird schwarz."
    plt.figure(1)
    plt.subplot(231)
    plt.imshow(img)
    plt.subplot(232)
    plt.imshow(img2)
    plt.subplot(233)
    plt.imshow(img3)
    plt.subplot(234)
    plt.imshow(img4)
    plt.subplot(235)
    plt.imshow(img5)
    plt.subplot(236)
    plt.imshow(img6)
    plt.show()

def aufgabe3b():
    img = imgToOneChannelGrayValue(plt.imread('nerds_blass.png'))
    img2 = grayValueStretch(img)
    plt.figure(1)
    plt.subplot(221)
    plt.imshow(img, norm=colors.NoNorm())
    plt.subplot(222)
    plt.imshow(img2, norm=colors.NoNorm())
    plt.subplot(223)
    plt.hist(img.reshape(img.size), bins=256, range=[0,1])
    plt.subplot(224)
    plt.hist(img2.reshape(img2.size), bins=256, range=[0,1])
    plt.show()


' Tests ausfuehren (bitte entsprechend ein-/ausklammern, sodass nur jeweils eine der Methoden ausgefuehrt wird): '

plt.gray()
#aufgabe2c()
#aufgabe3a()
aufgabe3b()

